; assemble with NASM and run bin2h on this

bits 16
org 0x1000


;	mov	al, 0x80
;	out	0x70, al	;  disable NMI

	mov	ax,0
	mov	ss,ax
	mov	sp, 0xff0
	mov	ds,ax

	jmp	0:a_label
a_label:

	
	lgdt	[temp_gdt32_ptr]

	; enable protected mode
	mov	eax, cr0
	or	eax, 1		
	mov	cr0, eax

	; jump to enable protected mode
	jmp	dword 0x8:start32bitcode

start32bitcode:

bits 32

	; set some sane segment registers
	mov	eax, 0x10
	mov	ds, ax
	mov	es, ax
	mov	ss, ax
	
	; stack goes here
	mov	esp, 0xfe0	
					
	;enable PAE
	mov	  eax, cr4
	bts	  eax, 5
	mov   cr4, eax
	
	; load our PML4, the kernel places a pointer a 0xff8
	mov   eax, dword [0xff8]
	mov   cr3, eax

	; enable long mode
	mov   ecx, 0xC0000080
	rdmsr
	bts   eax, 8
	wrmsr

	; activate long mode by enabling paging
	mov   eax, cr0
	bts   eax, 31
	mov	  cr0, eax			

	lgdt [temp_gdt64.pointer]

	jmp temp_gdt64.code:start64bitcode	

temp_gdt32_ptr:
	dw	3*8 - 1		;  length -1
	dd	temp_gdt32	;  physical address

temp_gdt32:
	dd	0, 0			; NULL

	dw	0xffff, 0		; 4GB code
	db	0, 0x9f, 0xcf, 0

	dw	0xffff, 0		; 4GB data
	db	0, 0x93, 0xcf, 0


temp_gdt64:
	dq 0x0000000000000000

.code equ $ - temp_gdt64
	dq 0x0020980000000000

.data equ $ - temp_gdt64
	dq 0x0000900000000000

.pointer:
	dw $-temp_gdt64-1
	dd temp_gdt64
	



	
[BITS 64]

start64bitcode:

	cli
 
    ; move stack high
	mov rax, 0xffffffff80000000
	add rax, rbp
	add rax, rsp

	cld
	
	; kernel passes us entry point at 0xff0
	; enter kernel 
	jmp qword [0xff0]

	; die 
	jmp $
	
