#include <arch/amd64/types.h>
#include <arch/amd64/mp.h>
#include <arch/amd64/apic.h>


void amd64_apic_ipi(uint64 apic_base_addr, uint32 dest, uint32 type, uint8 vec)
{
	amd64_apic_write(apic_base_addr,MP_LAPIC_ICR_HIGH_REG, dest << 24);
	amd64_apic_write(apic_base_addr,MP_LAPIC_ICR_LOW_REG, (uint32)(0x4000 | type | vec));
}

void amd64_apic_write(uint64 apic_base_addr, uint32 offset, uint32 value)
{
uint32 *p;

    p = (uint32*) ((uint64)apic_base_addr + offset);
	*p = value;
}

uint32 amd64_apic_read(uint64 apic_base_addr, uint8 offset)
{
uint32 *p;
uint32 val;

	p = (uint32*) ((uint64)apic_base_addr + offset);
	return (uint32)*p;
}

 