#define LINES 25
#define COLUMNS 80

#include <arch/amd64/types.h>
#include <arch/amd64/vm.h>

uint8 *videoMemory = (uint8*)KERNEL_VMA + 0xB8000;
uint16 curLine,curColumn = 0;

void inline debugconsole_sethwcursorpos(uint8 col, uint8 row)
{
int vidoff;    

    vidoff = row * (80*2) + (col*2);
    vidoff >>= 0x1;            

    outportb(0x3d4, 0x0f);
    outportb(0x3d5, vidoff & 0x0ff);
    outportb(0x3d4, 0x0e);
    outportb(0x3d5, vidoff >> 8);
}


void debugconsole_putChar(uint8 c, uint8 col)
{
int val;
uint16 offset,x,y;
uint8 *pos;
col = 0x7;


	pos = (uint8*)videoMemory;



	x = curColumn * 2;
	y = curLine * (COLUMNS*2);
	offset = x+y;

	switch(c)
	{
	case '\n' : {
		     curLine++;
		     curColumn = 0;
		     break;
		    }
	case '\t' : {
				curColumn = (curColumn + 8) & ~(8-1);
				break;
				}
	case '\r' : {
		     curColumn = 0;
		     break;
		    }
	case '\b' : {
	            if(curColumn > 0)
			curColumn --;
                    else
		    {
			curColumn = COLUMNS;
		        if(curLine > 0)
				curLine --;
			else
			{
				curColumn = 0;
				curLine = 0;
			}
		    }

		    break;
		    }
	default   :{
				pos[offset] = c;
				pos[offset+1] = col;
				curColumn++;
			    break;
                    }
	}
			


	
	if(curColumn > COLUMNS)
	{
		curColumn = 0;
		curLine++;
	}

	if(curLine >= LINES)
	{

		pos = (uint8*) ((uint64)videoMemory + (COLUMNS*2));
		kmemcpy(videoMemory,pos,LINES*COLUMNS*2);
		curLine = LINES - 1;

			
	}

	debugconsole_sethwcursorpos(curColumn,curLine);
	
}

void debugconsole_putString(uint8 *s)
{
uint8 c;
//int intstate;

//	intstate = interrupts(0);

	while(c=(*s++))
		debugconsole_putChar(c,0x3);

//	interrupts(intstate);
}
		
void debugconsole_init()
{
uint8 *p;
int i;

	//videoMemory = (uint8*)0xB8000 + KERNEL_PHYSICAL_AREA_START;
	p = (uint8*)videoMemory;
	
	for(i = 0 ;i<(25*80);i++)
	{
		p[0] = 0x20;
		p[1] = 0x7;
		p++; p++;
		
	}
	
}
