.align 16,0x90

.extern amd64_idt_enter_exception

.globl _amd64_isr0
.globl _amd64_isr1
.globl _amd64_isr2
.globl _amd64_isr3
.globl _amd64_isr4
.globl _amd64_isr5
.globl _amd64_isr6
.globl _amd64_isr7
.globl _amd64_isr8
.globl _amd64_isr9
.globl _amd64_isr10
.globl _amd64_isr11
.globl _amd64_isr12
.globl _amd64_isr13
.globl _amd64_isr14
.globl _amd64_isr15
.globl _amd64_isr16
.globl _amd64_isr17
.globl _amd64_isr18
.globl _amd64_isr_reserved

# TODO: Some exceptions push an error code.. allow for this


_amd64_isr0:
	push $0
	push $0
	jmp _amd64_isr_stub
	
_amd64_isr1:	
	push $0
	push $1
	jmp _amd64_isr_stub
	
_amd64_isr2:
	push $0
	push $2
	jmp _amd64_isr_stub
	
_amd64_isr3:
	push $0
	push $3
	jmp _amd64_isr_stub

_amd64_isr4:	
	push $0
	push $4
	jmp _amd64_isr_stub

_amd64_isr5:	
	push $0
	push $5
	jmp _amd64_isr_stub

_amd64_isr6:	
	push $0
	push $6
	jmp _amd64_isr_stub

_amd64_isr7:	
	push $0
	push $7
	jmp _amd64_isr_stub
	
_amd64_isr8:	
	push $0
	push $8
	jmp _amd64_isr_stub
	
_amd64_isr9:	
	push $0
	push $9
	jmp _amd64_isr_stub
	
_amd64_isr10:	
	push $0
	push $10
	jmp _amd64_isr_stub
	
_amd64_isr11:	
	push $0
	push $11
	jmp _amd64_isr_stub
	
_amd64_isr12:	
	push $0
	push $12
	jmp _amd64_isr_stub
	
_amd64_isr13:	
	push $0
	push $13
	jmp _amd64_isr_stub
	



_amd64_isr15:	
	push $0
	push $15
	jmp _amd64_isr_stub
	
_amd64_isr16:	
	push $0
	push $16
	jmp _amd64_isr_stub
	
_amd64_isr17:	
	push $0
	push $17
	jmp _amd64_isr_stub
	
_amd64_isr18:	
	push $0
	push $18
	jmp _amd64_isr_stub
	
_amd64_isr_reserved:	
	push $0
	push $0xff
	jmp _amd64_isr_stub





	
	
	
	

	


_amd64_isr_stub:

	push %rax
	push %rbx
	push %rcx
	push %rdx
	push %rdi
	push %rsi
	push %rbp
	push %r8
	push %r9
	push %r10
	push %r11
	push %r12
	push %r13
	push %r14
	push %r15

	push %fs
	push %gs
	
	mov $0x10, %ax
	mov %ax, %ds
	mov %ax, %fs
	mov %ax, %gs
	
	movq %rsp, %rdi
#	movq $5, %rsi
	call amd64_idt_enter_exception
	
	pop	%gs
	pop	%fs
	pop	%r15
	pop	%r14
	pop	%r13
	pop	%r12
	pop	%r11
	pop	%r10
	pop	%r9
	pop	%r8
	pop	%rbp
	pop	%rsi
	pop	%rdi
	pop	%rdx
	pop	%rcx
	pop	%rbx
	pop	%rax
	
	addq	$16, %rsp
	iretq
	
	
	
	

# page fault handler
_amd64_isr14:	
	push $14
	
	push %rax
	push %rbx
	push %rcx
	push %rdx
	push %rdi
	push %rsi
	push %rbp
	push %r8
	push %r9
	push %r10
	push %r11
	push %r12
	push %r13
	push %r14
	push %r15

	push %fs
	push %gs
	
	mov $0x10, %ax
	mov %ax, %ds
	mov %ax, %fs
	mov %ax, %gs
	
	movq %rsp, %rdi
	movq %cr2, %rsi
	call amd64_page_fault
	
	pop	%gs
	pop	%fs
	pop	%r15
	pop	%r14
	pop	%r13
	pop	%r12
	pop	%r11
	pop	%r10
	pop	%r9
	pop	%r8
	pop	%rbp
	pop	%rsi
	pop	%rdi
	pop	%rdx
	pop	%rcx
	pop	%rbx
	pop	%rax
	
	addq	$16, %rsp
	iretq	