#ifndef __INCLUDE_ALLOC_H
#define __INCLUDE_ALLOC_H

#include <types.h>

#define MM_PAGE_STATUS_AVAIL 0x0
#define MM_PAGE_STATUS_CHAINED 0x1
#define MM_PAGE_STATUS_CHAINED_LAST 0x2
#define MM_PAGE_STATUS_ALLOCATED 0x3


typedef struct mm_page_t
{

	size_t physical_address;
	struct mm_page_t *next;

	uint8 status;
	//struct mm_page_t *chained;
} mm_page_t;


void *mm_page_alloc();
void mm_page_free(void *addr);
void mm_page_free(void *addr);
void mm_page_free_cont(size_t index);
void *mm_page_alloc_cont(int no);

#endif 