#ifndef __INCLUDE_ARCH_AMD64_GDT_H
#define __INCLUDE_ARCH_AMD64_GDT_H

#define KERNEL_CS 0x8
#define KERNEL_DS 0x10
#define USER_CS 0x18
#define USER_DS 0x20

typedef struct amd64_gdt_desc
{
	/* segment limit bits 15-0 */
	unsigned seg_limit0:16;
	
	/* base address bits 15-0 */
	unsigned base_addr0:16;

	/* base address bits 31-24 */
	unsigned base_addr1:8;

	/* access flags */
	unsigned access_flags:8; 

	/* segment limit bits 19-16 */
	unsigned seg_limit1:4;

	
	unsigned spare:1;

	/* 64bit segment */
	unsigned longmode:1;
	
	unsigned special:1;
	unsigned graularity:1;
	unsigned base_addr2:8;
} __attribute__ ((packed)) amd64_gdt_desc;

typedef struct amd64_gdtr
{
	uint16 limit;
	uint64  address;
} __attribute__((packed)) amd64_gdtr;


#endif