#ifndef __INCLUDE_ARCH_AMD64_IDT_H
#define __INCLUDE_ARCH_AMD64_IDT_H

#include <arch/amd64/types.h>

#define AMD64_MASTER_PIC  0x20     
#define AMD64_MASTER_IMR  0x21     
#define AMD64_SLAVE_PIC  0xA0     
#define AMD64_SLAVE_IMR  0xA1     

#define AMD64_PIC_ICW1   0x11     
#define AMD64_PIC_ICW4   0x01     
#define AMD64_PIC_MASTER_VEC  0x68     
#define AMD64_PIC_SLAVE_VEC  0x70  



typedef struct amd64_stack_frame
{
	uint64 gs; 
	uint64 fs;
	uint64 r15; 
	uint64 r14;
	uint64 r13;
	uint64 r12;
	uint64 r11;
	uint64 r10;
	uint64 r9;
	uint64 r8;
	uint64 rbp;
	uint64 rsi;
	uint64 rdi;
	uint64 rdx;
	uint64 rcx;
	uint64 rbx;
	uint64 rax;
	uint64 int_no;
	uint64 error;
	uint64 rip;
	uint64 cs;
	uint64 eflags;
	uint64 rsp;
	uint64 ss;
} amd64_stack_frame;

typedef struct amd64_idtr
{
	uint16 limit;
	uint64 address;
} __attribute__((packed)) amd64_idtr;

typedef struct amd64_idt_desc
{

	uint16 base_addr0;
	uint16 selector;
	uint32 ist:3;
	uint32 always0:5;
	uint8 flags;
	uint16 base_addr1;
	uint32 base_addr2;
	uint32 reserved;

} __attribute__((packed)) amd64_idt_desc;

#endif