#include <arch/amd64/types.h>

#define KIRQ_MAX 256

typedef struct kirq_handler
{

	uint8 *owner;

	int (*handler)();
} kirq_handler;

struct kirq_handler kirq_handlers [KIRQ_MAX] = {0};

void kirq_recieve(uint16 irq_no)
{

	if(irq_no > KIRQ_MAX)
	{
	//	printk("kirq: IRQ out-of-range?\n");
		return;
	}

	if(kirq_handlers[irq_no].handler == NULL)
	{
	//	printk("kirq: unhandled IRQ #%i\n",irq_no);
		return;
	}

	kirq_handlers[irq_no].handler(irq_no);
	return;
}

int kirq_hook(uint16 irq_no, uint8 *owner, void *handler)
{

	if(irq_no > KIRQ_MAX)
		return -1;

	if(kirq_handlers[irq_no].handler != NULL)
		return -1;

	kirq_handlers[irq_no].handler = (void*)handler;
	kirq_handlers[irq_no].owner = (uint8*)owner;

	return 0;
}



int kirq_init()
{
int i;

	for(i=0 ; i < KIRQ_MAX; i++)
	{
		kirq_handlers[i].owner = NULL;
		kirq_handlers[i].handler = NULL;
	}

}
