#include <types.h>
#include <spinlock.h>


void spinlock_init(struct spinlock_t *lock)
{

	lock->holder = (uint8*)0;
	lock->lock = 0;
}

int spinlock_unlock(struct spinlock_t *lock)
{

	if(!lock)
	{
		printk("spinlock_unlock() !NULL\n");
		return -1;
	}

	if(lock->lock == 0)
	{
		printk("spinlock_unlock() LOCK NOT LOCKED!! 0x%p=%i\n",lock,lock->lock);
		return -1;
	}

	// do this atomically
	lock->lock = 0;
	return 0;
}

int spinlock_lock(struct spinlock_t *lock)
{

	if(!lock)
	{
		printk("spinlock_do_lock(%p) bad args\n",lock);
		return -1;
	}

	while(1)
	{

		if(atomic_test_and_set(&lock->lock) == 0)
			return 0;

	}


}
	